; This utility prints out the full file name of all files in the current folder and
;   all sub folders. It does not change folders or use recursion.  This is a console application.
.nolist
include \masm32\include\masm32rt.inc
.listall
.data
fcount  dd 0	; count files
.data?
FileN db 260 dup (?) 	; the current full path
pFile dd ?				; where the zerobyte terminator for path is.
.code
inv equ invoke

Program:
	call SetupGetNextFile
bigloop:
	call GetNextFile
	jc	PrintCount
   	print addr FileN,13,10	; not a folder, print the file name
   	inc fcount
	jmp bigloop	  
PrintCount:
    inv dwtoa,fcount,addr FileN
    print addr FileN," files total",13,10    
    inv ExitProcess, 0

.data?  ; for GetNextFile
wfd WIN32_FIND_DATA <?>
SearchHandle dd ?
LastFilePtr  dd ?
SearchPtrs dd 100 dup (?)   ; enough for 50 levels deep.  LastFilePtr,SearchHandle, etc.
Level	dd ?
pnt		dd ?	; offset into SearchPtrs
Phase	dd ?
.code

SetupGetNextFile proc
	inv GetCurrentDirectory,260,addr FileN  ; or you could hardcode any starting point
	add eax,offset FileN	; location of zero byte terminator
	mov pFile,eax
	mov Phase,0		; initialize process
	ret
SetupGetNextFile EndP

GetNextFile proc  ; assumes FileN contains full path to folder wanted,
                   ;   pFile points to zero byte terminator
	cmp Phase,0
	jne iloop		; everything is set up, just continue	
	mov Phase,1	
    mov eax,offset SearchPtrs
    mov pnt,eax		; start with first one
    mov	Level,1	   ; start at first level
ReStart:
	mov eax,pFile
	cmp byte ptr [eax-1],'\'	; add trailing slash if needed
	je 	HaveSlash
	mov word ptr [eax],005Ch	; backslash plus zero byte terminator
	inc eax
	inc pFile
HaveSlash:
	mov LastFilePtr,eax			; save pointer to end of string for this level
	mov ecx,pnt
	mov [ecx],eax				; save for going deeper into folders
	mov dword ptr [eax],002A2E2Ah	; set "*.*" search pattern, including zero byte terminator
    inv FindFirstFile,offset FileN,ADDR wfd
    mov SearchHandle,eax		; save search handle for this level
    mov ecx,pnt
    mov [ecx+4],eax				; save SearchHandle for going deeper into folders
    cmp eax,INVALID_HANDLE_VALUE  ; (-1)
    je	continue				; out of files, go move up or quit
	jmp @f						; already have one, skip over findnext

iloop:
	inv FindNextFile, SearchHandle,ADDR wfd
    or 	eax,eax
    jz 	CloseSearchHandle	; out of files in this folder
@@:
    mov edx,offset wfd.cFileName
    cmp byte ptr [edx],'.'	; discard current and parent directory
    je 	iloop
  	mov ecx,LastFilePtr		; still have address of wfd.cFileName in edx
@@:
	mov al,byte ptr [edx]	; tack new file or folder name onto current folder
	mov byte ptr [ecx],al
	inc edx
	inc ecx
	or 	al,al
	jnz	@b
    test wfd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY	; was it a new folder?
    jnz	DoNewFolder			; go do files in new folder
    ret		; return next file name

DoNewFolder:
	dec ecx
  	mov pFile,ecx		; save new pointer
  	add pnt,8			; next LastFilePtr,SearchHandle location
	inc Level			; keep track of how deep we are into subfolders
	jmp ReStart			; pFile already set, go get all the files in this new folder
	
CloseSearchHandle:
	inv FindClose,SearchHandle	; done with this search handle, close it
continue:
	dec	Level	; are we done
	jnz	@f
	mov Phase,0
	stc			; flag all done
	ret
@@:
	sub pnt,8	; back to previous set
	mov ecx,pnt
	mov eax,[ecx]	; get previous end of string pointer (LastFilePtr)
	mov pFile,eax
	mov LastFilePtr,eax ; back to where we started
	mov eax,[ecx+4]	; get last searchhandle
	mov SearchHandle,eax
    jmp iloop

GetNextFile endp

end Program





















